// Modified

/* 

   CS 202, Fall 2007
   Homework#5, Problem 3
   Author: Harish Kumar

*/
// Fig. 11.19: Complex.h
// Complex class definition.
#ifndef COMPLEX_H
#define COMPLEX_H

#include <iostream>
using std::ostream;
using std::istream;

class Complex
{
   friend ostream &operator<<( ostream &, const Complex & );
   friend istream &operator>>( istream &, Complex & );
public:
   Complex( double = 0.0, double = 0.0 ); // constructor
   Complex operator+( const Complex& ) const; // addition
   Complex operator-( const Complex& ) const; // subtraction
   Complex operator*( const Complex& ) const; // multiplication
   
private:
   double real; // real part
   double imaginary; // imaginary part
}; // end class Complex

#endif

/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
// Modified
/* 

   CS 202, Fall 2007
   Homework #5, Problem 3
   Author: Harish Kumar

*/
// Fig. 11.20: Complex.cpp
// Complex class member-function definitions.
//#include "Complex.h"

#include <iostream>
using std::cout;
using std::ostream;
using std::istream;

// Constructor
Complex::Complex( double realPart, double imaginaryPart )
   : real( realPart ),
   imaginary( imaginaryPart )
{
     // empty body
} // end Complex constructor

// addition operator
Complex Complex::operator+( const Complex &operand2 ) const
{
   return Complex( real + operand2.real,
      imaginary + operand2.imaginary );
} // end function operator+

// subtraction operator
Complex Complex::operator-( const Complex &operand2 ) const
{
   return Complex( real - operand2.real,
      imaginary - operand2.imaginary );
} // end function operator-

// multiplication operator
Complex Complex::operator*( const Complex &operand2 ) const
{
   return Complex(
      ( real * operand2.real ) - ( imaginary * operand2.imaginary ),
      ( real * operand2.imaginary ) + ( imaginary * operand2.real ) );
} // end function operator*

// overloaded output operator
ostream& operator<<( ostream &output, const Complex &complex )
{
   output << "(" << complex.real << "," << complex.imaginary << ")";
   return output;
} // end function operator<<

// overloaded input operator
istream& operator>>( istream &input, Complex &complex )
{
   input.ignore(); // skip (
   input >> complex.real;
   input.ignore(); // skip ',' 
   input >> complex.imaginary;
   input.ignore(); // skip )
   return input;
} // end function operator>>


/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/

/* 
   CS 202, Fall 2007
   Homework#5, Problem 3
   Author: Instructor (Dr.Roth)
*/ 

#include <iostream>
using std::cout;
using std::endl;
using std::cin;

//#include "Complex.h"

int main()	// driver to test Complex operations & I/O
{
    Complex a, b, c;
	cout<<"enter 2 complex numbers of form (real,imaginary)\n"; // Modified
	cin >> a >> b;
	c = a + b; cout << a << " + " << b << " = " << c << endl;
	c = a * b; cout << a << " * " << b << " = " << c << endl;
	return 0;
} // end main

/* OUTPUT:
enter 2 complex numbers of form (real,imaginary)
(1,1)(-1,1)
(1,1) + (-1,1) = (0,2)
(1,1) * (-1,1) = (-2,0)
*/

